字号对应的机内字体：

> 倍高倍宽：表示 X、Y 轴的增量乘以2，默认为1

| 字号   | 字体         |
| ---- | ---------- |
| 16   | font1      |
| 20   | font2      |
| 24   | font0      |
| 28   | font3      |
| 32   | font1 倍高倍宽 |
| 40   | font2 倍高倍宽 |
| 48   | font0 倍高倍宽 |
| 56   | font3 倍高倍宽 |



### sample code:

> TSPL打印协议，iOS SDK

```objective-c
- (void)printText {
    
    PTCommandTSPL *tsc = [[PTCommandTSPL alloc] init];
    
    [tsc initCMDQueue];
    
    [tsc setPrintAreaSizeWithWidth:100 Height:100];
    [tsc setCLS];
    
    [tsc appendTextWithXPos:0 YPos:0 FontSize:16 Rotation:0 Text:@"16号字体"];
    [tsc appendTextWithXPos:0 YPos:20 FontSize:20 Rotation:0 Text:@"20号字体"];
    [tsc appendTextWithXPos:0 YPos:40 FontSize:24 Rotation:0 Text:@"24号字体"];
    [tsc appendTextWithXPos:0 YPos:60 FontSize:28 Rotation:0 Text:@"28号字体"];
    [tsc appendTextWithXPos:0 YPos:80 FontSize:32 Rotation:0 Text:@"32号字体"];
    [tsc appendTextWithXPos:0 YPos:120 FontSize:40 Rotation:0 Text:@"40号字体"];
    [tsc appendTextWithXPos:0 YPos:160 FontSize:48 Rotation:0 Text:@"48号字体"];
    [tsc appendTextWithXPos:0 YPos:200 FontSize:56 Rotation:0 Text:@"56号字体"];
    
    [tsc printWithSets:1 Copies:1];
    
    NSData *cmdData = [tsc generateCMDData];
    NSLog(@"cmdData:%@",cmdData);
    [[PTDispatcher share] sendData:cmdData];
}
```

