# 如何连线便携式无线打印机

### 连接打印机

```objective-c
    [[PTDispatcher share] scanPrinter:^(PTPrinter *printer) {
        // 发现新打印机
    }];
    
    [[PTDispatcher share] scanPrinters:^(NSDictionary *printerDict) {
       // 发现打印机，返回当前已搜索到的所有打印机
       // 如果要显示蓝牙列表，可以在这里把 Dictionary 中的值绑定 TableView, 直接刷新 Table
    }];

	[[PTDispatcher share] scanWiFi:^(NSDictionary *printerDict) {
       // 发现WiFi打印机
    }];
    
    [[PTDispatcher share] connectPrinter:printer]; 	//连接指定的打印机
    [[PTDispatcher share] disConnectPrinter]; 		// 断开与打印机的连接
    [[PTDispatcher share] stopScanBluetooth]; 		// 停止蓝牙扫描
```

###  获取打印机状态

> 当断开蓝牙时，下列获取相关状态的方法失效（Block 被置空），下一次连接时，必须重新执行下列方法

```objective-c
	[[PTDispatcher share] whenConnectSuccess:^{
        // 当连接打印机成功
    }];
    
    [[PTDispatcher share] whenConnectFailure:^{
        // 当连接打印机失败
    }];
    
    [[PTDispatcher share] whenUnconnect:^{
        // 当与打印机断开
    }];
    
    [[PTDispatcher share] whenReadRSSI:^(NSNumber *RSSI) {
        // 当更新已连接打印机的信号强度 RSSI
    }];
    
    [[PTDispatcher share] whenReceiveData:^(NSData *receiveData) {
       // 收到打印机返回的数据
    }];
```



